'---------------------------------------------------------------------------
'      program: TAP READer
'       author: mados@tap-home.de
'     language: PowerBASIC 3.2
' last changed: 09.09.2001
'---------------------------------------------------------------------------

'$compile exe ".\tapread.exe"
$cpu 80386
$float npx
$sound 1
$com 0
$lib all off
$error all off
$event off
defint a-z

color 14,0: ?"TAP READer";: color 15: ?" von mados"

dim issue(1:3) as string
if dir$("TM1_DATA.DAT")<>"" then                    'look for the data files
  issue(1)="TM1_DATA.DAT"
elseif dir$("TAPMAG1\TM1_DATA.DAT")<>"" then
  issue(1)="TAPMAG1\TM1_DATA.DAT"
end if
if dir$("TM2_DATA.DAT")<>"" then
  issue(2)="TM2_DATA.DAT"
elseif dir$("TAPMAG2\TM2_DATA.DAT")<>"" then
  issue(2)="TAPMAG2\TM2_DATA.DAT"
end if
if dir$("TM3_DATA.DAT")<>"" then
  issue(3)="TM3_DATA.DAT"
elseif dir$("TAPMAG3\TM3_DATA.DAT")<>"" then
  issue(3)="TAPMAG3\TM3_DATA.DAT"
end if

for i=1 to 3
  if len(issue(i)) then
    ? using "TAP_.MAG _#[#]";i
    file$=issue(i): inum=i
    incr c                                     'count number of issues found
  end if
next

if c<1 then
  ?"Es wird mindestens eine Ausgabe bentigt, um den TAP READer benutzen zu"
  ?"knnen. Unter http://www.tap-home.de sollte das TAP.MAG zu finden sein."
  end
elseif c>1 then
  ?"Bitte eine der Zahlentasten drcken..."
  RepeatInput:
  select case input$(1)                             'wait for keyboard input
    case chr$(27): end
    case "1": file$=issue(1): inum=1
    case "2": file$=issue(2): inum=2
    case "3"
    case else: goto RepeatInput
  end select
end if

screen 0,,0,0: call logo(inum)

'---------------------------------------------------------------------------

type articletype
  file as string*8                                        'internal filename
  title as string*30                                   'title of the article
  author as string*18                                                'author
  ptr as long                                     'start pointer of the text
  lines as integer                                          'number of lines
end type
dim a(0:16) as articletype                     'maximum count is 17 articles

open file$ for input as #1
do
  line input #1,z$                                            'skip comments
loop while len(z$)<1 or ascii(z$)=47
do
  a(aanz).file=z$
  line input #1,a(aanz).title
  line input #1,a(aanz).author
  if(inum>1) then
    line input #1,z$                                   'read number of pages
    a(aanz).ptr=seek(1)
    for i=2 to val(z$)*16                    'read at least pages*16-1 lines
      line input #1,z$
      incr a(aanz).lines
      if eof(1) then exit
    next
  else
    z$=""
    a(aanz).ptr=seek(1)
  end if
  tkey$="tm"+ltrim$(str$(inum))
  while not eof(1) and left$(z$,3)<>tkey$                'break if key found
    line input #1,z$
    incr a(aanz).lines
  wend
  decr a(aanz).lines,2
  incr aanz
loop until eof(1)
close
decr aanz

'---------------------------------------------------------------------------

for i=1 to aanz-1                            'move some articles to top/down
  if instr(a(i).file,"_edi") then
    swap a(0),a(i)
  elseif instr(a(i).file,"_hlp") then
    swap a(1),a(i)
  elseif instr(a(i).file,"_end") then
    swap a(aanz),a(i)
  end if
next

'---------------------------------------------------------------------------

while 1
  for i=0 to aanz                                     'display the main menu
    locate i+6,25
    if i=selected then
      color 14: ? "(";ucase$(rtrim$(a(i).title));") ";
    else
      color 6: ? "   ";lcase$(a(i).title);
    end if
  next
  i$="": while i$="": i$=inkey$: wend                        'wait for a key
  select case i$
    case chr$(27),chr$(0,107),chr$(0,68)                     'esc,alt+f4,f10
      color 7,0: cls: exit loop
    case chr$(13)," "                                          'return,space
      open file$ for input as #1
      call article(inum,a(selected))
      close
      call logo(inum)
    case chr$(0,72),chr$(0,75),chr$(0,15)                                'up
      if selected>0 then decr selected
    case chr$(0,80),chr$(0,77),chr$(9)                                 'down
      if selected<aanz then incr selected
    case chr$(0,71): selected=0                                       'first
    case chr$(0,79): selected=aanz                                     'last
    case chr$(0,73): decr selected,8                                'page up
      if selected<0 then selected=0
    case chr$(0,81): incr selected,8                              'page down
      if selected>aanz then selected=aanz
  end select
wend

'---------------------------------------------------------------------------

sub article(inum,a as articletype)
  seek #1,a.ptr
  dim z(0:a.lines+15) as string
  for i=0 to a.lines
    line input #1,z(i)                                       'read all lines
    z(i)=rtrim$(z(i))
    if len(rtrim$(z(i),any "! "))>1 then nlines=i        'look for last line
  next
  a.lines=nlines
  dim f(1:9)
  if(inum=1) then
    f(1)=6: f(3)=14: f(4)=9: f(5)=14: f(6)=2                   'color tables
  else
    f(3)=4: f(4)=9: f(5)=14: f(6)=2: f(7)=14: f(8)=3: f(9)=15
  end if
  color 3,0
  for i=1 to 25
    locate i,21: ? space$(40);                                 'clear screen
  next
  locate 4,21: ? string$(38-len(rtrim$(a.title)),196);" ";
  color 14: ? rtrim$(a.title);
  locate 23,21: ? rtrim$(a.author);
  color 3: ? " ";string$(33-len(rtrim$(a.author)),196);"";
  while 1
    color 9
    for i=0 to 15
      locate i+6,21: ? space$(40);: locate ,21
      if inum=1 then
        farbe=val(left$(z(i+first),1))
        if farbe>0 then color f(farbe)
        ? mid$(z(i+first),2);
      else
        x$=z(i+first)
        p=instr(x$,"|")                             'look for colors in text
        while p
          ? left$(x$,p-1);
          farbe=val(mid$(x$,p+1,1))
          if farbe>=3 then color f(farbe)
          x$=mid$(x$,p+2)
          p=instr(x$,"|")
        wend
        ? x$;
      end if
    next
    color 14: locate 23,57
    ? using "###%";100*(first\16+1)/(a.lines\16+1);         'display counter

    i$="": while i$="": i$=inkey$: wend             'wait for keyboard input
    select case i$
      case chr$(27): exit loop                                          'esc
      case chr$(0,71): first=0                                        'first
      case chr$(0,79): first=(a.lines\16)*16                           'last
      case chr$(8),chr$(0,73),chr$(0,72),chr$(0,75)                 'page up
        if first>0 then decr first,16
      case " ",chr$(13),chr$(0,81),chr$(0,80),chr$(0,77)          'page down
        if first<a.lines-15 then incr first,16
    end select
  wend
end sub

'---------------------------------------------------------------------------

sub logo(inum)
  color 4,0: cls
  for i=1 to 25
    s=sin(i/2+3)*2
    locate i,1: ? string$(14+s,178);"";                 'display sinus bars
    locate ,65+s: ? "";string$(15-s,178);
  next
  color 14
  locate 4,21: ? "TAP.MAG #";ltrim$(str$(inum));" ";
  color 3
  ? "";string$(28,196);
  if inum=1 then locate 23,21 else locate 24,21
  ? string$(40,196);
end sub
